#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_texture;

varying vec4 v_color;
varying vec2 v_texCoord;

uniform float animationControl;
uniform vec2 resolution;

void main () {

    vec2 pos = gl_FragCoord.xy / resolution.xy;

    vec4 t_color = texture2D (u_texture, v_texCoord);

    float anim = sin (animationControl * 0.5 * 3.14) * 0.5;
    if (pos.x > 0.5 + anim || pos.x < 0.5 - anim) {

        t_color.a = 0.0;

    }


    vec4 final_color = v_color * t_color;
    gl_FragColor = final_color;

}