#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_texture;
uniform sampler2D u_lightmap;

varying vec4 v_color;
varying vec2 v_texCoord;

uniform float time;
uniform float randomFactor;
uniform vec2 resolution;
uniform vec4 ambient;
uniform int enablecrt;

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void main () {

    vec2 pos = gl_FragCoord.xy / resolution.xy;

    /*float t_color_red = texture2D (u_texture, v_texCoord + vec2 (sin(pos.y * 8.0 * 3.14 + time * 2.0) * 0.005, 0.0)).r;
    float t_color_green = texture2D (u_texture, v_texCoord + vec2 (cos(pos.y * 8.0 * 3.14 + time * 2.0 + 0.08) * 0.005, 0.0)).g;
    float t_color_blue = texture2D (u_texture, v_texCoord + vec2 (sin(pos.y * 8.0 * 3.14 + time * 2.0 + 0.16) * 0.005, 0.0)).b;
    vec4 t_color = vec4 (t_color_red, t_color_green, t_color_blue, 1.0);*/
    vec2 final_texcoord = v_texCoord
                                  + (randomFactor > 0.0 ?
                                  vec2 (rand(vec2(randomFactor, randomFactor + 0.23)) * randomFactor, sin(time * 6.0) * randomFactor)
                                  : vec2 (0.0));
    vec4 l_color = vec4 (texture2D (u_lightmap, final_texcoord).rgb, 1.0);
    vec4 t_color = texture2D (u_texture, final_texcoord);

    vec4 final_color = v_color * t_color * ambient + l_color;

	if (enablecrt == 1) {
	    float crt = sin (pos.y * (resolution.y * 4.0)) * 0.5 + 0.5;
	    crt += cos (pos.x * (resolution.y * 4.0)) * 0.5 + 0.5;
        crt -= (sin (pos.y * (resolution.y * 0.025) + time) * 0.5 + 0.5) * 0.2;

        vec4 crtvec = vec4 (crt, crt, crt, 1.0);
        final_color *= crtvec;

	}

    gl_FragColor = final_color;

}